﻿USE [QLSV_NHOM]
GO
ALTER DATABASE QLSV_NHOM
SET COMPATIBILITY_LEVEL = 150
GO

--Insert Nhân viên
ALTER procedure SP_INS_PUBLIC_NHANVIEN @MANV varchar(20), @HOTEN nvarchar(100), @EMAIL varchar (100),@LUONG int,@TENDN nvarchar(100),@MATKHAU varchar(100)
as
begin
   DECLARE @C NVARCHAR(MAX) = 
    'create asymmetric key PUB_'+ @MANV +'
        with algorithm = RSA_2048
        encryption by password = '''+@MATKHAU+''''
    EXEC(@C);

	insert into nhanvien values (@MANV,@HOTEN,@EMAIL,ENCRYPTBYASYMKEY(ASYMKEY_ID('PUB_'+@MANV),CAST(@LUONG as varchar(100))),@TENDN,HASHBYTES('SHA1',@MATKHAU),@MANV)
end
GO

EXEC SP_INS_PUBLIC_NHANVIEN 'NV03', 'NGUYEN VAN A', 'NVA@',300000, 'NVA', 'abcd12'
GO

--Insert Sinh viên
create proc SP_INS_SINHVIEN
@MASV NVARCHAR(50), @HOTEN NVARCHAR(100), @NGAYSINH DATETIME, @DIACHI NVARCHAR(100), @MALOP VARCHAR(50),@TENDN VARCHAR(50),@MATKHAU VARCHAR(50)
AS
BEGIN
	DECLARE @MKMAHOA VARBINARY(MAX) = HASHBYTES('MD5',@MATKHAU)
	INSERT INTO SINHVIEN
	VALUES(@MASV,@HOTEN,@NGAYSINH,@DIACHI,@MALOP,@TENDN,@MKMAHOA)
END
EXEC SP_INS_SINHVIEN 'SV01', 'NGUYEN VAN A', '1990-1-1', '280 AN DUONG VUONG', 'CNTT-K35', 'NVA', '123456'
EXEC SP_INS_SINHVIEN 'SV02', 'NGUYEN VAN b', '1990-6-13', '280 AN DUONG VUONG', 'CNTT-K46', 'NVB', '123456'
EXEC SP_INS_SINHVIEN 'SV03', 'NGUYEN VAN C', '1990-9-25', '280 AN DUONG VUONG', 'KH01', 'NVC', '123456'
go

ALTER PROC SP_SEL_SINHVIEN
@MALOP VARCHAR(20)
AS
BEGIN
	SELECT MASV,HOTEN,NGAYSINH,DIACHI,TENDN FROM SINHVIEN WHERE SINHVIEN.MALOP =@MALOP;
END
Exec SP_SEL_SINHVIEN 'KH01'
GO


-- cau ii
--Select nhân viên
alter procedure SP_SEL_PUBLIC_NHANVIEN @TENDN nvarchar(100),@MATKHAU varchar(1000)
as
begin
	select MANV, HOTEN, EMAIL,CONVERT(VARCHAR(max),  
    DecryptByAsymKey( AsymKey_Id('PUB_'+MANV),   
    LUONG, N''+@MATKHAU+'' ))  as LUONGCB
	from NHANVIEN
	where TENDN=@TENDN and MATKHAU=HASHBYTES('SHA1',@MATKHAU)
end 
exec  SP_SEL_PUBLIC_NHANVIEN 'NVA', 'abcd12'
GO

--cau d
EXEC SP_INS_PUBLIC_NHANVIEN 'NV01', 'NGUYEN VAN A', 'nva@yahoo.com',
300000, 'NVA', '123456'
EXEC SP_INS_PUBLIC_NHANVIEN 'NV02', 'NGUYEN VAN B', 'nvb@yahoo.com',
200000, 'NVB', '1234567'
GO

CREATE PROC SP_CHECK_SV
@TENDN VARCHAR(50), @MATKHAU VARCHAR(50)
AS
BEGIN
	DECLARE @MAHOAMK VARBINARY(MAX) = HASHBYTES('SHA1',@MATKHAU)
	select HOTEN from SINHVIEN WHERE TENDN = @TENDN AND MATKHAU = @MAHOAMK 
END
GO

ALTER PROC SP_CHECK_NV
@TENDN VARCHAR(50), @MATKHAU VARCHAR(50)
AS
BEGIN
	DECLARE @MAHOAMK VARBINARY(MAX) = HASHBYTES('SHA1',@MATKHAU)
	select HOTEN,MANV from NHANVIEN WHERE  TENDN = @TENDN AND MATKHAU = @MAHOAMK 
END
GO

ALTER PROC SP_SEL_LOP 
as
begin
	select MALOP, TENLOP,HOTEN from LOP,NHANVIEN WHERE LOP.MANV =NHANVIEN.MANV
end
go

exec SP_SEL_LOP
go
CREATE PROC SP_CHECK_LOP
@MALOP VARCHAR(20)
AS
BEGIN
	SELECT MALOP FROM LOP WHERE MALOP=@MALOP
END
GO

CREATE PROC SP_INS_LOP
@MALOP VARCHAR(20), @TENLOP NVARCHAR(100), @HOTEN NVARCHAR(100)
AS
BEGIN
	DECLARE @MANV VARCHAR(20) = (SELECT MANV FROM NHANVIEN WHERE HOTEN=@HOTEN);
	INSERT INTO LOP
	VALUES(@MALOP,@TENLOP,@MANV)
END
GO
EXEC SP_INS_LOP 'KH03','KHOA HỌC MÁY TÍNH','NGUYEN VAN A'
EXEC SP_INS_LOP 'KH04','MẠNG MÁY TÍNH','NGUYEN VAN A'
GO

CREATE PROC SP_SEL_NAME_NV
AS
BEGIN
	SELECT HOTEN FROM NHANVIEN
END
GO

ALTER PROC SP_UPD_LOP
@MALOP VARCHAR(20), @TENLOP NVARCHAR(100), @HOTEN NVARCHAR(100)
AS
BEGIN
	DECLARE @MANV VARCHAR(20) = (SELECT MANV FROM NHANVIEN WHERE HOTEN=@HOTEN);
	UPDATE LOP
	SET MANV=@MANV ,TENLOP=@TENLOP WHERE MALOP=@MALOP
END 
GO

EXEC SP_UPD_LOP 'KH03','MẠNG MÁY','NGUYEN VAN B';

CREATE PROC SP_CHECK_MALOP
@MALOP VARCHAR(20)
AS
BEGIN
	SELECT MALOP FROM LOP WHERE MALOP=@
END
GO

ALTER PROC SP_SEL_NAME_LOP
AS
BEGIN
	SELECT TENLOP FROM LOP
END
EXEC SP_SEL_NAME_LOP

GO


CREATE PROC SP_CNT_SV_LOP
@MALOP VARCHAR(50)
AS
BEGIN
	SELECT COUNT(MASV) AS SOLUONG FROM SINHVIEN,LOP WHERE LOP.MALOP =@MALOP AND SINHVIEN.MALOP = LOP.MALOP 
END

EXEC SP_CNT_SV_LOP 'CNTT-K35'

ALTER PROC SP_UPD_SV_NO_PASSWORD
@MASV NVARCHAR(50), @HOTEN NVARCHAR(100), @NGAYSINH DATETIME, @DIACHI NVARCHAR(100), @MALOP VARCHAR(50),@TENDN VARCHAR(50)
AS
BEGIN
	UPDATE SINHVIEN
	SET HOTEN= @HOTEN ,NGAYSINH =@NGAYSINH, DIACHI =@DIACHI,MALOP = @MALOP,TENDN =@TENDN WHERE MASV=@MASV 
END
GO

ALTER PROC SP_UPD_SV_PASSWORD
@MASV NVARCHAR(50), @HOTEN NVARCHAR(100), @NGAYSINH DATETIME, @DIACHI NVARCHAR(100), @MALOP VARCHAR(50),@TENDN VARCHAR(50) ,@MATKHAU VARCHAR(50)
AS
BEGIN
	DECLARE @MKMAHOA VARBINARY(MAX) = HASHBYTES('MD5',@MATKHAU);
	UPDATE SINHVIEN
	SET HOTEN= @HOTEN ,NGAYSINH =@NGAYSINH, DIACHI =@DIACHI,MALOP = @MALOP,TENDN =@TENDN,MATKHAU =@MKMAHOA WHERE MASV=@MASV 

END
GO

ALTER PROC SP_SEL_DIEM
@MALOP VARCHAR(20),@MATKHAU nVARCHAR(20)
AS
BEGIN
	DECLARE @MANV VARCHAR(20) = (SELECT MANV FROM LOP WHERE MALOP=@MALOP );
	SELECT SINHVIEN.MASV,HOTEN, 
	CONVERT(nvarchar(max),DECRYPTBYASYMKEY(ASYMKEY_ID('PUB_' +@MANV), DIEMTHI, N''+@MATKHAU+''))as DIEMTHI FROM BANGDIEM,SINHVIEN WHERE BANGDIEM.MASV =SINHVIEN.MASV and BANGDIEM.MALOP = @MALOP
END
GO
EXEC SP_SEL_DIEM 'KH05','abcd12'
CREATE PROC SP_INS_DIEM
@MASV VARCHAR(20),@MALOP VARCHAR(20),@DIEM FLOAT
AS
BEGIN
	DECLARE @MANV VARCHAR(20) = (SELECT MANV FROM LOP WHERE MALOP=@MALOP );
	INSERT INTO BANGDIEM VALUES( @MASV,@MALOP,ENCRYPTBYASYMKEY(ASYMKEY_ID('PUB_'+@MANV),CAST(@DIEM as varchar(100))))
END
GO
alter PROC SP_UPD_DIEM
@MASV VARCHAR(20),@MALOP VARCHAR(20),@DIEM FLOAT
AS
BEGIN
	DECLARE @MANV VARCHAR(20) = (SELECT MANV FROM LOP WHERE MALOP=@MALOP );
	UPDATE BANGDIEM SET MALOP=@MALOP,DIEMTHI=ENCRYPTBYASYMKEY(ASYMKEY_ID('PUB_'+@MANV),CAST(@DIEM as varchar(100))) where MASV=@MASV
END
GO

CREATE PROC SP_CHECK_NVCHAMDIEM
@MALOP VARCHAR(20)
AS
BEGIN
	SELECT MANV FROM LOP WHERE MALOP=@MALOP;
END

EXEC SP_CHECK_NVCHAMDIEM


